config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  root to: 'activities#index'
  get '/activities', to: redirect('/')
  resources :actors, only: [:index, :show] do
    collection do
      get :lookup, to: 'actors#lookup'
    end
    resources :activities, only: [:index]
  end
  get :feed, to: 'activities#feed'
  resources :followings, only: [:create, :destroy] do
    collection do
      post :follow, to: 'followings#follow'
    end

    member do
      put :accept, to: 'followings#accept'
    end
  end
  resources :notes
  resources :users, except: [:new, :create, :destroy]

  get '/.well-known/webfinger', to: 'web_finger#find', as: :webfinger
  get '/.well-known/host-meta', to: 'web_finger#host_meta', as: :host_meta
  get '/.well-known/nodeinfo', to: 'web_finger#node_info', as: :node_info
  get '/nodeinfo/2.0', to: 'web_finger#show_node_info', as: :show_node_info

  namespace :federation do
    resources :actors, only: [:show] do
      member do
        get :followers
        get :following
      end
      get :outbox, to: 'activities#outbox'
      post :inbox, to: 'activities#create'
      resources :activities, only: [:show]
      resources :followings, only: [:show]
      resources :notes, only: [:show]
    end
  end
end

app/models/note.rb
class Note < ApplicationRecord
  include Routeable

  validates :content, presence: true

  belongs_to :actor
  # FIXME: Handle this with something like undelete
  has_many :activities, as: :entity, dependent: :destroy

  after_create :create_activity

  def federated_url
    attributes['federated_url'].presence || federation_actor_note_url(actor_id: actor_id, id: id)
  end

  private

  def create_activity
    Activity.create! actor: actor, action: 'Create', entity: self
  end
end

app/controllers/federation/notes_controller.rb
module Federation
  class NotesController < FederationApplicationController
    before_action :set_note, only: [:show]

    # GET /federation/actors/1/notes/1.json
    def show; end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_note
      @note = Note.find_by!(actor_id: params[:actor_id], id: params[:id])
      authorize @note
    end
  end
end

app/controllers/notes_controller.rb
class NotesController < ApplicationController
  before_action :set_note, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!, except: [:index, :show]

  # GET /notes
  # GET /notes.json
  def index
    @notes = policy_scope Note.all
  end

  # GET /notes/1
  # GET /notes/1.json
  def show; end

  # GET /notes/new
  def new
    @note = Note.new
  end

  # GET /notes/1/edit
  def edit; end

  # POST /notes
  # POST /notes.json
  def create # rubocop:disable Metrics/AbcSize
    @note       = Note.new(note_params)
    @note.actor = current_user.actor

    respond_to do |format|
      if @note.save
        format.html { redirect_to @note, notice: I18n.t('controller.notes.create.success') }
        format.json { render :show, status: :created, location: @note }
      else
        format.html { render :new }
        format.json { render json: @note.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /notes/1
  # PATCH/PUT /notes/1.json
  def update
    respond_to do |format|
      if @note.update(note_params)
        format.html { redirect_to @note, notice: I18n.t('controller.notes.update.success') }
        format.json { render :show, status: :ok, location: @note }
      else
        format.html { render :edit }
        format.json { render json: @note.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /notes/1
  # DELETE /notes/1.json
  def destroy
    @note.destroy
    respond_to do |format|
      format.html { redirect_to notes_url, notice: I18n.t('controller.notes.destroy.success') }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_note
    @note = Note.find(params[:id])
    authorize @note
  end

  # Only allow a list of trusted parameters through.
  def note_params
    params.require(:note).permit(:content)
  end
end

app/views/notes/_form.html.haml
= form_for note do |f|
  - if note.errors.any?
    .error_explanation
      %h2 #{pluralize(note.errors.count, 'error')} prohibited this note from being saved:
      %ul
        - note.errors.full_messages.each do |message|
          %li= message

  .field
    = f.label :content
    = f.text_area :content
  .actions
    = f.submit 'Save'

app/views/notes/edit.html.haml
%h1 Editing note

= render 'form', note: @note

= link_to 'Show', @note
\|
= link_to 'Back', notes_path

app/views/notes/index.html.haml
%h1 Listing notes

%table
  %thead
    %tr
      %th Content
      %th Actor
      %th

  %tbody
    - @notes.each do |note|
      %tr
        %td= note.content
        %td= note.actor.name
        %td
          = link_to 'Show', note
          - if policy(note).edit?
            = link_to 'Edit', edit_note_path(note)
          - if policy(note).destroy?
            = link_to 'Destroy', note, method: :delete, data: { confirm: 'Are you sure?' }

- if policy(Note).new?
  = link_to 'New Note', new_note_path

app/views/notes/new.html.haml
%h1 New note

= render 'form', note: @note

= link_to 'Back', notes_path

app/views/notes/show.html.haml
%p
  %b Content:
  = @note.content
%p
  %b Actor:
  = @note.actor.name

- if policy(@note).edit?
  = link_to 'Edit', edit_note_path(@note)
\|
= link_to 'Back', notes_path